import java.util.NoSuchElementException;

import org.svetovid.io.SvetovidReader;
import org.svetovid.io.SvetovidWriter;

/**
 * Format:
 *
 * br
 * id leviId desniId vrednost (x br)
 */
public class StabloIOClassic implements StabloIO {

    @Override
    public Stablo readStablo(SvetovidReader in) {
        int br = in.readInt();
        Stablo stablo = null;
        for (int i = 0; i < br; i++) {
            int id = in.readInt();
            int leviId = in.readInt();
            int desniId = in.readInt();
            String vrednost = in.readLine();
            Stablo levi = leviId == -1 ? null : new Stablo(leviId);
            Stablo desni =desniId == -1 ? null : new Stablo(desniId);
            Stablo element = new Stablo(id, vrednost, levi, desni);
            stablo = insert(stablo, element);
        }
        return stablo;
    }

    private static Stablo insert(Stablo stablo, Stablo element) {
        if (stablo == null) {
            return element;
        }
        Stablo found = find(stablo, element.id);
        if (found == null) {
            throw new NoSuchElementException("id: " + element.id);
        }
        found.vrednost = element.vrednost;
        found.levi = element.levi;
        found.desni = element.desni;
        return stablo;
    }

    private static Stablo find(Stablo stablo, int id) {
        if (stablo == null) {
            return null;
        }
        if (stablo.id == id) {
            return stablo;
        }
        Stablo rezultat = find(stablo.levi, id);
        if (rezultat != null) {
            return rezultat;
        }
        return find(stablo.desni, id);
    }

    @Override
    public void printStablo(SvetovidWriter out, Stablo stablo) {
        int br = count(stablo);
        out.println(br);
        iterate(out, stablo);
    }

    private static int count(Stablo stablo) {
        if (stablo == null) {
            return 0;
        }
        return 1 + count(stablo.levi) + count(stablo.desni);
    }

    private static void iterate(SvetovidWriter out, Stablo stablo) {
        if (stablo == null) {
            return;
        }
        int id = stablo.id;
        int leviId = stablo.levi == null ? -1 : stablo.levi.id;
        int desniId = stablo.desni == null ? -1 : stablo.desni.id;
        String vrednost = stablo.vrednost;
        out.println(id, leviId, desniId, vrednost);
        iterate(out, stablo.levi);
        iterate(out, stablo.desni);
    }
}
